﻿#define VSG_DEBUG

#region

using System;
using System.Drawing;
using MMDD.CG.Model.Sprite;
using MMF;
using MMF.CG.Camera.CameraMotion;
using MMF.CG.Kinect;
using MMF.CG.Model.Grid;
using MMF.CG.Model.Shape;
using MMF.CG.Model.Sprite.D2D;
using SlimDX;
using SlimDX.DirectWrite;
using Brush = SlimDX.Direct2D.Brush;

#endregion

namespace CGTest
{
    public partial class Form1 : D2DSupportedRenderForm
    {
        public static ColorTexture ColTexture;
        private Brush brush;

        private TestChildForm form;
        private TestChildForm form1;
        private TestChildForm form2;
        private D2DSpriteTextformat format;

        private IDynamicTexture tex2;

        public Form1()
        {
            InitializeComponent();
        }

        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);
            KeyPreview = true;
            KinectDeviceManager dev = null;

            #region Kinectテストコード

#if KINECT
            OpenNIManager.Initialize();
            dev = OpenNIManager.getDevice();

            ColTexture = new ColorTexture(RenderContext, dev);
            tex2 = new DepthTexture(RenderContext, 1000, dev);
#endif

            #endregion

            //format = SpriteBatch.CreateTextformat("Meiriyo", 30, FontWeight.ExtraBold);


            //brush = SpriteBatch.CreateRadialGradientBrush(g,
            //    new RadialGradientBrushProperties() {CenterPoint = new PointF(100,100),GradientOriginOffset = new PointF(0,0),HorizontalRadius = 100f,VerticalRadius = 200f}).Brush;
            //brush = SpriteBatch.CreateSolidColorBrush(Color.Aquamarine);
            ScreenContext.CameraMotionProvider = new BasicCameraControllerMotionProvider(this, this);
            BasicGrid gird = new BasicGrid();
            gird.Visiblity = true;
            gird.Load(RenderContext);

            ScreenContext.WorldSpace.AddResource(gird);
            form = new TestChildForm(RenderContext);

            form.Show();
            RenderContext.UpdateReqireWorlds.Add(form.WorldSpace);
            form.ScreenContext.CameraMotionProvider = new BasicCameraControllerMotionProvider(form, form);
            ControlForm controlForm = new ControlForm(RenderContext, ScreenContext,form.ScreenContext, dev);
            controlForm.Show();
            

            #region Kinectテストコード

#if KINECT
            PlaneBoard bill = new PlaneBoard(RenderContext, ColTexture.TextureResourceView);
            bill.Transformer.Position = new Vector3(0, 0, 50);
            //bill.Transformer.Rotation *= Quaternion.RotationAxis(new Vector3(0,1,0),(float) (Math.PI));
            form.WorldSpace.AddResource(bill);
            form.WorldSpace.AddDynamicTexture(ColTexture);
#endif

            #endregion
        }

        public override void OnUpdated()
        {
            base.OnUpdated();
        }

        /// <summary>
        ///     ここでスプライト描画
        /// </summary>
        protected override void RenderSprite()
        {
            //SpriteBatch.DWRenderTarget.FillRectangle(brush,SpriteBatch.FillRectangle);
            //SpriteBatch.DWRenderTarget.DrawText(
            //    string.Format("FPS:{0}\n\nBrush Test!!", FpsCounter.FPS.ToString("####.#")), format,
            //    SpriteBatch.FillRectangle, brush);
        }

        protected override void OnPresented()
        {
            base.OnPresented();
            if(form.Visible)form.Render();
        }
    }
}