﻿using SlimDX;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace MMDFileParser.PMXModelParser
{
    public class IKLink
    {
        internal static IKLink getIKLink(FileStream fs,Header header)
        {
            IKLink ikLink=new IKLink();
            ikLink.LinkBoneIndex=ParserHelper.getIndex(fs,header.BoneIndexSize);
            ikLink.isRotateLimited=ParserHelper.getByte(fs)==1?true:false;
            if(ikLink.isRotateLimited)
            {
                ikLink.MinimumRadian=ParserHelper.getFloat3(fs);
                ikLink.MaximumRadian=ParserHelper.getFloat3(fs);
            }
            return ikLink;
        }
        public int LinkBoneIndex { get; private set; }
        public bool isRotateLimited { get; private set; }
        public Vector3 MinimumRadian { get; private set; }
        public Vector3 MaximumRadian { get; private set; }
    }
}
