﻿using System.Collections.Generic;
using SlimDX;

namespace MMDFileParser.XParser
{
    /// <summary>
    /// 頂点に関する情報を格納するインターフェース
    /// </summary>
    public interface IXModel
    {
        /// <summary>
        /// ポジションリスト
        /// </summary>
        List<Vector3> PositionList { get; }
   
        /// <summary>
        /// 法線リスト
        /// </summary>
        List<Vector3> NormalList { get; }
 
        /// <summary>
        /// ポジションリストのインデックス
        /// </summary>
        List<IFace> PositionFaces { get; }

        /// <summary>
        /// 法線リストのインデックス
        /// </summary>
        List<IFace> NormalFaces { get; }
        
        /// <summary>
        /// n番目の面に割り当てられているマテリアルのインデックス。
        /// Materials[MaterialIndicies[n]]がその面の材質になるように。
        /// </summary>
        List<int> MaterialIndicies { get; } 

        /// <summary>
        /// 材質のリスト
        /// </summary>
        List<IMaterial> Materials { get; }

    }
}