using System.Collections;
using System.IO;
using System.Text;

namespace MMDFileParser.XParser{

public class StringData
{
    public string Name {get;set;}
    public string data;
    public ArrayList child {get;set;}

    public static StringData getStringDataFromStream(Stream stream)
    {
        StreamReader sr = new StreamReader(stream, Encoding.GetEncoding("Shift_JIS"));
        string text = sr.ReadToEnd();

        sr.Close();

        return new StringData("root", removeComment(text));
    }

    public StringData(string n, string txt)
    {
        int start, end, datai;
        string head, content;

        Name = n;
        data = "";
        child = new ArrayList();

        findCorrespondingParen(txt, out start, out end);

        // if txt has no child, add data
        if (start == -1) data = txt.Substring(0, txt.Length-1).Trim();

        // if txt has child
        while (start != -1) {
            head = txt.Substring(0, start).Trim();
            content = txt.Substring(start+1, end-start);
            datai = head.LastIndexOf(";");

            // if head has data (data...; name), add data and fix head
            if (datai != -1) {
                data = head.Substring(0, datai).Trim();
                head = head.Substring(datai+1).Trim();
            }
            child.Add(new StringData(head, content));

            txt = txt.Substring(end+1);
            findCorrespondingParen(txt, out start, out end);
        }
    }

    private void findCorrespondingParen(string txt, out int first, out int second)
    {
        int num=0;
        int cnt=-1;

        first = txt.IndexOf('{');
        second = 0;

        foreach (var c in txt) {
            cnt++;
            if (c == '{') num++;
            else if (c == '}') num--;
            else continue;
            if (num == 0) { second = cnt; return; }
        }
    }

    static string removeComment(string txt)
    {
        int start = txt.IndexOf("//");
        int len;

        while (start != -1) {
            len = txt.Substring(start).IndexOf('\n');
            txt = txt.Remove(start, len-1);
            start = txt.IndexOf("//");
        }

        return txt;
    }
}

}
