﻿using System.Collections.Generic;
using NiTEWrapper;
using OpenNIWrapper;

namespace MMF.CG.Kinect
{
    public class OpenNIManager
    {
        private static OpenNIManager fakeInstance;

        private static List<Device> createdDevices=new List<Device>(); 

        public static DeviceInfo[] ConnectedDevices;

        internal OpenNIManager()
        {
        }

        ~OpenNIManager()
        {
            OpenNI.Shutdown();
            NiTE.Shutdown();
            foreach (var createdDevice in createdDevices)
            {
                createdDevice.Close();
            }
        }

        public static void Initialize()
        {
            OpenNI.Shutdown();//例外などで前回シャットダウンされなかった場合用
            OpenNI.Initialize();
            NiTE.Initialize();
            ConnectedDevices=OpenNI.EnumerateDevices();
            OpenNI.onDeviceConnected += OpenNI_onDeviceConnected;
            OpenNI.onDeviceDisconnected+=OpenNI_onDeviceConnected;
            OpenNI.onDeviceStateChanged += OpenNI_onDeviceStateChanged;
            fakeInstance=new OpenNIManager();
        }

        static void OpenNI_onDeviceStateChanged(DeviceInfo Device, OpenNI.DeviceState state)
        {
            ConnectedDevices = OpenNI.EnumerateDevices();
        }

        static void OpenNI_onDeviceConnected(DeviceInfo Device)
        {
            ConnectedDevices = OpenNI.EnumerateDevices();
        }

        public static KinectDeviceManager getDevice(string uri=null)
        {
            Device d = Device.Open(uri);
            createdDevices.Add(d);
            return new KinectDeviceManager(d);
        }
    }
}
