﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Input;
using MMF.CG.Camera;
using MMF.CG.MMEEffect.VariableSubscriber;
using MMF.CG.Projection;
using SlimDX;

namespace MMF.CG.Light
{
    public class LightMatrixManager
    {
        public LightMatrixManager(MatrixManager manager)
        {
            this.manager = manager;
            Camera = new BasicCamera(new Vector3(0, 0, -20), new Vector3(0, 0, 0), new Vector3(0, 1, 0));
            Projection=new BasicProjectionMatrixProvider();
        }

        private MatrixManager manager;
        private Vector3 direction;

        public CameraProvider Camera { get; private set; }

        public BasicProjectionMatrixProvider Projection { get; private set; }

        public Vector3 Position
        {
            get
            {
                return Camera.CameraPosition;
            }
            set
            {
                Camera.CameraPosition = value;
                UpdateDirection();
            }
        }

        private void UpdateDirection()
        {
            direction = Vector3.Normalize(-Camera.CameraPosition);
        }

        public Vector3 Direction
        {
            get { return direction; }
            private set { direction = value; }
        }
    }
}
