﻿using System;
using SlimDX;

namespace MMF.CG.Model
{
    /// <summary>
    /// 描画可能リソースのインターフェース
    /// </summary>
    public interface IDrawable : IDisposable
    {

        /// <summary>
        ///     表示されているかどうかを判定する変数
        /// </summary>
        bool Visiblity { get; }

        /// <summary>
        /// ファイル名を格納する変数
        /// </summary>
        string FileName { get; }

        int SubsetCount { get; }

        int VertexCount { get; }

        /// <summary>
        ///     モデルを動かす際に使用するクラス
        /// </summary>
        ITransformer Transformer { get; }

        /// <summary>
        ///     モデルを描画するときに呼び出します。
        /// </summary>
        void Draw();

        /// <summary>
        ///     モデルを更新するときに呼び出します
        /// </summary>
        void Update();

        Vector4 SelfShadowColor { get; set; }

        Vector4 GroundShadowColor { get; set; }
    }
}