﻿using System;
using System.Collections.Generic;
using MMF.CG.MMEEffect;
using MMF.CG.Model.MMD;
using SlimDX.Direct3D11;

namespace MMF.CG.Model
{
    /// <summary>
    ///     レンダリングの方法を引き受けるインターフェース
    /// </summary>
    public interface ISubsetManager : IDisposable
    {
        void Initialze(object _model, Device device, MMEEffectManager effect, ISubresourceLoader subresourceManager,
            IToonTextureManager ToonManager);

        void ResetEffect(MMEEffectManager effect);

        void DrawAll();

        void DrawEdges();

        void DrawGroundShadow();

        int SubsetCount { get; }

        List<PMXSubset> Subsets { get;}
    }
}