﻿using System.Collections.Generic;
using MMF.CG.Motion;

namespace MMF.CG.Model.MMD.Morph
{
    /// <summary>
    /// モーフの管理クラスのインターフェース
    /// </summary>
    public interface IMMDMorphManager
    {
        /// <summary>
        /// モーフのモーションから再生
        /// </summary>
        /// <param name="frame"></param>
        /// <param name="morphs"></param>
        void ApplyMorphProgress(float frame, IEnumerable<FaceMotion> morphs);

        /// <summary>
        /// 指定したモーフのフレームをセットする
        /// </summary>
        /// <param name="frame"></param>
        /// <param name="morphName"></param>
        void ApplyMorphProgress(float frame, string morphName);

        /// <summary>
        /// フレームがリセットされるとき(Updateのタイミングで呼び出す)
        /// </summary>
        void UpdateFrame();
    }
}