﻿using System;
using MMF.CG.MMEEffect.VariableSubscriber.MaterialSubscriber;
using MMDFileParser.PMXModelParser;
using SlimDX.Direct3D11;

namespace MMF.CG.Model.MMD
{
    /// <summary>
    ///     描画単位
    /// </summary>
    public class PMXSubset : IDisposable, ISubset
    {
        public MaterialInfo MaterialInfo { get; private set; }

        public int SubsetId { get; private set; }

        public PMXSubset(IDrawable drawable,MaterialData data,int subsetId)
        {
            Drawable = drawable;
            MaterialInfo = MaterialInfo.FromMaterialData(Drawable, data);
            SubsetId = subsetId;
        }

        /// <summary>
        ///     インデックスバッファにおける、このリソースの開始点
        /// </summary>
        public int StartIndex { get; set; }


        /// <summary>
        ///     このリソースに含まれる頂点数
        /// </summary>
        public int VertexCount { get; set; }

        public void Dispose()
        {
            if(MaterialInfo!=null)MaterialInfo.Dispose();
        }

        public IDrawable Drawable { get; set; }

        public bool DoCulling { get; set; }
    }
}