﻿
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using MMF.CG.MMEEffect;
using MMF.CG.Utility;
using MMDFileParser.XParser;
using SlimDX;
using SlimDX.Direct3D11;
using Buffer = SlimDX.Direct3D11.Buffer;
using Debug = System.Diagnostics.Debug;
using Mesh = MMDFileParser.XParser.Mesh;

namespace MMF.CG.Model.XFile
{
    public class XFileModel:IDrawable
    {
        public void Initialize(Stream stream, RenderContext context)
        {
            //this.RenderContext = context;
            //Visiblity = true;
            //StringData data = StringData.getStringDataFromStream(stream);
            //XObj xfileObj = XParser.getXObject(data);
            //Mesh mesh = (Mesh) xfileObj.getObj("Mesh");
            //Mesh normals = (Mesh) mesh.getObj("Mesh");
            //List<BasicInputLayout> inputVerticies=new List<BasicInputLayout>();
            //if(mesh.nFaces!=normals.nFaces)throw new InvalidOperationException("法線の数と頂点の数が違います");
            //for (int i = 0; i < mesh.nFaces; i++)
            //{
            //    BasicInputLayout layoutX=new BasicInputLayout();
            //    layoutX.Position = new Vector4(mesh.vertices[(int)mesh.faces[i].X],1);
            //    layoutX.Normal=normals.vertices[(int)normals.faces[i].X];
            //    layoutX.Index = (uint) mesh.faces[i].X;
            //    BasicInputLayout layoutY = new BasicInputLayout();
            //    layoutY.Position = new Vector4(mesh.vertices[(int)mesh.faces[i].Y], 1);
            //    layoutY.Normal = normals.vertices[(int)normals.faces[i].Y];
            //    layoutY.Index = (uint)mesh.faces[i].Y;
            //    BasicInputLayout layoutZ = new BasicInputLayout();
            //    layoutZ.Position = new Vector4(mesh.vertices[(int)mesh.faces[i].Z], 1);
            //    layoutZ.Normal = normals.vertices[(int)normals.faces[i].Z];
            //    layoutZ.Index = (uint)mesh.faces[i].Z;
            //    inputVerticies.Add(layoutX);
            //    inputVerticies.Add(layoutY);
            //    inputVerticies.Add(layoutZ);
            //}
            //VertexCount = mesh.nFaces*3;
            //SubsetCount = 1;
            //VertexBuffer = CGHelper.CreateBuffer(inputVerticies, context.DeviceManager.Device, BindFlags.VertexBuffer);
            //Transformer=new BasicTransformer();
            //Transformer.Scale=new Vector3(10f);
            //effect = MMEEffectManager.Load("Shader\\Xshader.fx", this, RenderContext, new BasicSubresourceLoader("Shader"));
            //InputLayout = new InputLayout(context.DeviceManager.Device, effect.EffectFile.GetTechniqueByIndex(0).GetPassByIndex(0).Description.Signature, BasicInputLayout.VertexElements);
        }

        private RenderContext RenderContext { get; set; }

        private InputLayout InputLayout { get; set; }

        private Buffer VertexBuffer { get; set; }

        private MMEEffectManager effect { get; set; }
 
        private List<XSubset> Subsets=new List<XSubset>(); 


        public void Dispose()
        {
            if (VertexBuffer != null && !VertexBuffer.Disposed) VertexBuffer.Dispose();
            if (InputLayout != null && !InputLayout.Disposed) InputLayout.Dispose();
        }

        public bool Visiblity { get; private set; }

        public string FileName { get; private set; }
        public int SubsetCount { get; private set; }
        public int VertexCount { get; private set; }

        public ITransformer Transformer { get; private set; }

        public void Draw()
        {
            RenderContext.DeviceManager.Context.InputAssembler.SetVertexBuffers(0,new VertexBufferBinding(VertexBuffer,BasicInputLayout.SizeInBytes,0));
            RenderContext.DeviceManager.Context.InputAssembler.InputLayout = InputLayout;
            RenderContext.DeviceManager.Context.InputAssembler.PrimitiveTopology=PrimitiveTopology.TriangleList;
            effect.ApplyAllMatrixVariables();
            effect.EffectFile.GetTechniqueByIndex(0).GetPassByIndex(0).Apply(RenderContext.DeviceManager.Context);
            RenderContext.DeviceManager.Context.Draw(VertexCount,0);

        }

        public void Update()
        {
        }

        public Vector4 SelfShadowColor { get; set; }
        public Vector4 GroundShadowColor { get; set; }
    }
}
