﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using MMF.CG.Utility;
using MMDFileParser.MotionParser;
using SlimDX.Direct3D9;

namespace MMF.CG.Motion
{
    public class FaceMotion
    {
        /// <summary>
        /// モーションのフレームごとのデータ
        /// </summary>
        public List<FaceFrameData> Frames { get; private set; }

        /// <summary>
        /// モーフの名前
        /// </summary>
        public string Morphname { get; private set; }

        public FaceMotion(string morphName)
        {
            Frames=new List<FaceFrameData>();
            Morphname = morphName;
        }

        /// <summary>
        /// 指定したボーンを補完する
        /// </summary>
        /// <param name="target">補完するボーン</param>
        /// <param name="frame">フレーム位置</param>
        public float Lerp(float frame)
        {
            for (int j = 0; j < Frames.Count - 1; j++)
            {
                if (Frames[j].FrameNumber < frame && Frames[j + 1].FrameNumber >= frame)
                {
                    //フレームが挟まれている時
                    uint frameMargin = Frames[j + 1].FrameNumber - Frames[j].FrameNumber;
                    float progress = (frame - Frames[j].FrameNumber) / (float)frameMargin;
                    return CGHelper.Lerp(Frames[j].FaceValue, Frames[j + 1].FaceValue, progress);
                }
            }
            return Frames[0].FaceValue;
        }
    }
}
