﻿using System.Collections.Generic;
using MMF.CG.Model.MMD.Morph;
using SlimDX.Direct3D11;

namespace MMF.CG.Skinning
{
    public interface ISkinningProvider : System.IDisposable
    {
        Bone[] Bone { get; }

        Dictionary<string,Bone> BoneDictionary { get; }
        
        List<Bone> IkBone { get; }

        List<ITransformUpdater> KinematicsProviders { get; }

        /// <summary>
        ///     モーションデータをエフェクトに適用する際に呼び出します。
        /// </summary>
        /// <param name="effect"></param>
        void ApplyEffect(Effect effect);

        /// <summary>
        ///     フレームごとにスキニングのデータを更新するために呼び出します。
        /// </summary>
        /// <param name="morph"></param>
        void UpdateSkinning(IMMDMorphManager morph);

        /// <summary>
        ///     関節のすべての回転をリセットします。
        /// </summary>
        void ResetAllBoneTransform();
    }
}