﻿using SlimDX;

namespace MMF.CG.Skinning
{
    /// <summary>
    ///     IKリンクに関わるデータ
    /// </summary>
    public class IkLink
    {
        private readonly int index;
        private readonly ISkinningProvider skinning;

        /// <summary>
        ///     回転量制限があるかどうか
        /// </summary>
        public bool isLimited = false;

        /// <summary>
        ///     最大回転量(X,Y,Z)
        /// </summary>
        public Vector3 maxRot;

        /// <summary>
        ///     最小回転量(X,Y,Z)
        /// </summary>
        public Vector3 minRot;

        public int loopCount;

        public IkLink(ISkinningProvider skinning, int index)
        {
            this.skinning = skinning;
            this.index = index;
        }

        /// <summary>
        ///     ikリンクボーン
        /// </summary>
        public Bone ikLinkBone
        {
            get { return skinning.Bone[index]; }
        }
    }
}