﻿using MMF.CG.Physics;
using MMDFileParser.PMXModelParser;

namespace MMF.CG.Skinning
{
    internal class SkeletonWithPhysics : Skeleton
    {
        private readonly PhysicsTransformManager physicsTransformManager;

        public SkeletonWithPhysics(ModelData model) : base(model)
        {
            physicsTransformManager = new PhysicsTransformManager(Bone, model.RigidBodyList.RigidBodies, model.JointList.Joints);
            KinematicsProviders.Add(physicsTransformManager);
        }

        public override void Dispose()
        {
            physicsTransformManager.Dispose();
        }
    }
}